from typing import List, Optional, Union

import terrascript.core as core


@core.resource(type="aws_dx_connection_confirmation", namespace="aws_direct_connect")
class DxConnectionConfirmation(core.Resource):

    connection_id: Union[str, core.StringOut] = core.attr(str)

    id: Union[str, core.StringOut] = core.attr(str, computed=True)

    def __init__(
        self,
        resource_name: str,
        *,
        connection_id: Union[str, core.StringOut],
        depends_on: Optional[Union[List[str], core.ArrayOut[core.StringOut]]] = None,
        provider: Optional[Union[str, core.StringOut]] = None,
        lifecycle: Optional[core.Lifecycle] = None,
    ):
        super().__init__(
            name=resource_name,
            args=DxConnectionConfirmation.Args(
                connection_id=connection_id,
                depends_on=depends_on,
                provider=provider,
                lifecycle=lifecycle,
            ),
        )

    @core.schema_args
    class Args(core.Resource.Args):
        connection_id: Union[str, core.StringOut] = core.arg()
